"""
API endpoints routes definitions
"""

from django.urls import path
from vernaclarify.views import (get_patch_taxon,
                                get_taxon_main_scientific_name,
                                get_taxon_parents,
                                get_taxon_list_by_name,
                                get_patch_taxon_identifiers,
                                get_taxon_identifiers_history,
                                get_taxon_vernaculars_history,
                                get_taxon_scientifics_history,
                                post_vernacular, get_patch_delete_vernacular,
                                get_taxon_vernacular_list,
                                post_scientific, get_patch_delete_scientific,
                                get_taxon_scientific_list)

urlpatterns = [
    path("vernacular/",
         post_vernacular,
         name="post_vernacular"),
    path("vernacular/<int:vernacular_id>/",
         get_patch_delete_vernacular,
         name="get_patch_delete_vernacular"),
    path("scientific/",
         post_scientific,
         name="post_scientific"),
    path("scientific/<int:scientific_id>/",
         get_patch_delete_scientific,
         name="get_patch_delete_scientific"),
    path("taxon/<int:taxon_id>/",
         get_patch_taxon,
         name="get_patch_taxon"),
    path("taxon/<int:taxon_id>/main-scientific-name/",
         get_taxon_main_scientific_name,
         name="get_taxon_main_scientific_name"),
    path("taxon/<int:taxon_id>/parents/",
         get_taxon_parents,
         name="get_taxon_parents"),
    path("taxon/<int:taxon_id>/vernaculars/",
         get_taxon_vernacular_list,
         name="get_taxon_vernacular_list"),
    path("taxon/<int:taxon_id>/scientifics/",
         get_taxon_scientific_list,
         name="get_taxon_scientific_list"),
    path("taxon/<int:taxon_id>/identifiers/",
         get_patch_taxon_identifiers,
         name="get_patch_taxon_identifiers"),
    path("taxa/name/startswith/<str:partial_name>/",
         get_taxon_list_by_name,
         {'filter_type': 'startswith'},
         name="get_taxon_list_by_name_startswith"),
    path("taxa/name/contains/<str:partial_name>/",
         get_taxon_list_by_name,
         {'filter_type': 'contains'},
         name="get_taxon_list_by_name_contains"),
    path("taxon/<int:taxon_id>/identifiers/history/",
         get_taxon_identifiers_history,
         name="get_taxon_identifiers_history"),
    path("taxon/<int:taxon_id>/vernaculars/history/",
         get_taxon_vernaculars_history,
         name="get_taxon_vernaculars_history"),
    path("taxon/<int:taxon_id>/scientifics/history/",
         get_taxon_scientifics_history,
         name="get_taxon_scientifics_history"),
]
